// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlProgressIcon")]
    pub struct ProgressIcon(Object<ffi::DzlProgressIcon, ffi::DzlProgressIconClass>) @extends gtk::DrawingArea, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_progress_icon_get_type(),
    }
}

impl ProgressIcon {
    #[doc(alias = "dzl_progress_icon_new")]
    pub fn new() -> ProgressIcon {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_progress_icon_new()).unsafe_cast() }
    }

    #[doc(alias = "dzl_progress_icon_get_progress")]
    #[doc(alias = "get_progress")]
    pub fn progress(&self) -> f64 {
        unsafe { ffi::dzl_progress_icon_get_progress(self.to_glib_none().0) }
    }

    #[doc(alias = "dzl_progress_icon_set_progress")]
    pub fn set_progress(&self, progress: f64) {
        unsafe {
            ffi::dzl_progress_icon_set_progress(self.to_glib_none().0, progress);
        }
    }

    #[doc(alias = "progress")]
    pub fn connect_progress_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_progress_trampoline<F: Fn(&ProgressIcon) + 'static>(
            this: *mut ffi::DzlProgressIcon,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::progress\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_progress_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for ProgressIcon {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for ProgressIcon {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ProgressIcon")
    }
}
